#include <stdio.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>

#include "ctest.h"

#define ROTXOR(n,m) (n << m) ^ (n >> (32-m))

#define MIX(a,b,c)                      \
    a -= c; a ^= ROTXOR(c,  4); c += b; \
    b -= a; b ^= ROTXOR(a,  6); a += c; \
    c -= b; c ^= ROTXOR(b,  8); b += a; \
    a -= c; a ^= ROTXOR(c, 16); c += b; \
    b -= a; b ^= ROTXOR(a, 19); a += c; \
    c -= b; c ^= ROTXOR(b,  4); b += a

#define FINAL(a,b,c)            \
    c ^= b; c -= ROTXOR(b, 14); \
    a ^= c; a -= ROTXOR(c, 11); \
    b ^= a; b -= ROTXOR(a, 25); \
    c ^= b; c -= ROTXOR(b, 16); \
    a ^= c; a -= ROTXOR(c,  4); \
    b ^= a; b -= ROTXOR(a, 14); \
    c ^= b; c -= ROTXOR(b, 24)

#define read_char(data,i,n)     \
    ((uint32_t)((unsigned char *)data)[i] << n)

uint32_t hash(void *data, size_t size)
{
    uint32_t *ptr = data;
    uint32_t  a;
    uint32_t  b;
    uint32_t  c;

    a = b = c = 0xdeadbeef + (uint32_t)size;

    for(; size > 12; size -= 12, ptr += 3) {
        a += read_char(ptr,  0, 24) | read_char(ptr,  1, 16)
           | read_char(ptr,  2,  8) | read_char(ptr,  3,  0);
        b += read_char(ptr,  4, 24) | read_char(ptr,  5, 16)
           | read_char(ptr,  6,  8) | read_char(ptr,  7,  0);
        c += read_char(ptr,  8, 24) | read_char(ptr,  9, 16)
           | read_char(ptr, 10,  8) | read_char(ptr, 11,  0);
        MIX(a,b,c);
    }

    switch(size) {
        case 12:    c += read_char(ptr, 11,  0);
        case 11:    c += read_char(ptr, 10,  8);
        case 10:    c += read_char(ptr,  9, 16);
        case  9:    c += read_char(ptr,  8, 24);
        case  8:    b += read_char(ptr,  7,  0);
        case  7:    b += read_char(ptr,  6,  8);
        case  6:    b += read_char(ptr,  5, 16);
        case  5:    b += read_char(ptr,  4, 24);
        case  4:    a += read_char(ptr,  3,  0);
        case  3:    a += read_char(ptr,  2,  8);
        case  2:    a += read_char(ptr,  1, 16);
        case  1:    a += read_char(ptr,  0, 24);    break;
        default:    return c;
    }

    FINAL(a,b,c);
    return c;
}
